<script setup lang="ts">
import { useCategoryStore } from "@/stores/category";
import { useOrderStore } from "@/stores/order";
import { usePromotionStore } from "@/stores/promotion";
import { onMounted, ref } from "vue";
import type { VForm } from "vuetify/components";
const form = ref<VForm | null>(null);
const promotionStore = usePromotionStore();
const orderStore = useOrderStore();
async function save() {
    // โค้ดการตรวจสอบความถูกต้องของข้อมูลและเซฟ order
}
onMounted(async () => {
    promotionStore.getPromotion()
});
//ใช้โปรโม
function applyDiscount(promotionId: number | undefined) {
    const promotion = promotionStore.promotions.find(promo => promo.id === promotionId!);
    if (promotion) {
        orderStore.setDiscount(promotion.discount);
        promotionStore.usePro = false;
    } else {
        console.error("Promotion not found!");
    }
}

const formatDate = (endDate: string) => {
    const date = new Date(endDate);
    const day = date.getDate().toString().padStart(2, '0'); // Add leading zero if single digit
    const monthNamesThai = [
        "ม.ค.", "ก.พ.", "มี.ค.", "เม.ย.", "พ.ค.", "มิ.ย.",
        "ก.ค.", "ส.ค.", "ก.ย.", "ต.ค.", "พ.ย.", "ธ.ค."
    ];
    const month = monthNamesThai[date.getMonth()]; // Get Thai month name
    const year = date.getFullYear().toString().slice(-2); // Get last two digits of the year
    return `${day} ${month} ${year}`;
};

</script>

<template>
    <v-dialog v-model="promotionStore.usePro" persistent width="1024">
        <v-card>
            <v-card-title>
                <span class="text-h5">โปรโมชัน</span>
            </v-card-title>
            <v-card-text>
                <v-form ref="form">
                    <v-container>
                        <v-row>
                            <div>รายละเอียดโปรโมชัน</div>
                        </v-row>
                        <v-row>
                            <v-col cols="2" fluid v-for="item of promotionStore.promotions" :key="item.id">
                                <v-card class="ma-5" style="width:350px; height: 150px;">
                                    <v-card-actions class="flex-row">
                                        <div class="item-details">
                                            <div class="promotion-name ">{{ item.name }}</div>
                                            <div>{{ item.description }}</div>
                                            <div>เริ่มตั้งแต่ {{ formatDate(item.startDate.toString()) }} </div>
                                            <div>ถึง {{ formatDate(item.endDate.toString()) }}</div>
                                        </div>
                                        <div class="divider">|||||</div> <!-- เส้นแบ่งแนวตั้ง -->
                                        <div class="button-container">
                                            <v-btn class="green-button" @click="applyDiscount(item.id)">
                                                ใช้
                                            </v-btn>
                                        </div>
                                    </v-card-actions>
                                </v-card>
                            </v-col>
                        </v-row>
                    </v-container>
                </v-form>
            </v-card-text>
            <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="promotionStore.usePro = false">
                    ปิด
                </v-btn>
            </v-card-actions>
        </v-card>
    </v-dialog>
</template>

<style scoped>
.flex-row {
    display: flex;
    align-items: center;
    /* จัดให้อยู่กลางแนวด้านตั้ง */
}

.item-details {
    flex: 1;
    /* ทำให้ข้อมูลขยายเต็มพื้นที่ที่เหลือ */
}

.divider {
    height: 100%;
    /* ทำให้เส้นแบ่งขยายเต็มความสูง */
    width: 1px;
    /* กำหนดความกว้างของเส้นแบ่ง */
}

.button-container {
    margin-left: 10px;
    /* จัดให้ปุ่มชิดขวา */
}

.promotion-name {
    font-weight: bold;
    /* ตั้งค่าตัวอักษรให้เป็นตัวหนา */
    font-size: 25px;
    /* กำหนดขนาดตัวอักษร */
}

.green-button {
    background-color: rgb(102, 218, 102);
    /* กำหนดสีพื้นหลังเป็นสีเขียว */
    color: white;
    /* กำหนดสีตัวอักษรเป็นสีขาว */
}
</style>